<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	version="2.0">
<import href="functions/SeafPersistenceBusinessFunctions.xsl" />
<output method="text" />

<template match="//per:persistence/per:entity">
	<variable name="entity-class" select="@name" />
	<variable name="entity-full-type" select="per:entity-full-type(.)" />
	<variable name="criteria-full-type" select="per:entity-criteria-full-type(.)" />
	<variable name="criteria-class" select="seaf:type-class($criteria-full-type)" />
	<variable name="dao-full-type" select="per:dao-full-type(.)" />
	<variable name="dao-class" select="seaf:type-class($dao-full-type)" />
	<variable name="controller-base-full-type" 
		select="per:controller-base-full-type(.)" />
	<variable name="controller-base-class" 
		select="seaf:type-class($controller-base-full-type)" />
	<variable name="full-type" select="per:controller-impl-base-full-type(.)" />
	<variable name="class" select="seaf:type-class($full-type)" />
	<variable name="dir" select="seaf:type-dir($full-type)" />
	<variable name="package" select="seaf:type-package($full-type)" />
	<variable name="type-label" select="per:persistent-object-type-label(.)" />
	<variable name="pk-type" select="per:persitent-object-pk-type(.)" />

<result-document href="{$dir}/{$class}.java">

<text />/**
 * GENERATED BY Seaf Persistence Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;
<if test="@code-table='time-bound'">
import java.util.Calendar;<text />
</if>
import java.util.List;
<if test="@code-table='time-bound'">
import net.sf.seaf.common.Operator;<text />
</if>
import net.sf.seaf.common.Page;<text />
<if test="@code-table">
import net.sf.seaf.persistence.exception.CodeNotFoundException;
import net.sf.seaf.persistence.exception.CodeNotValidException;<text />
</if>
<if test="@code-table='time-bound'">
import net.sf.seaf.persistence.exception.MultipleValidCodesException;<text />
</if>

import <value-of select="$controller-base-full-type" />;
import <value-of select="$entity-full-type" />;
import <value-of select="$criteria-full-type" />;
import <value-of select="$dao-full-type" />;<text />

/**
 * The <value-of select="$entity-class" /> server controller base class.
 * Implements common controller methods for the <text />
 	<value-of select="$entity-class" /><text> </text>
 	<value-of select="$type-label" />.
 */
public class <value-of select="$class" /> implements <text />
	<value-of select="$controller-base-class" /> {

	/**
	 * The DAO of the <value-of select="$entity-class" /><text> </text>
	 	<value-of select="$type-label" />.
	 */
	private <value-of select="$dao-class" /> dao;

	public <value-of select="$entity-class" /> create(<text />
		<value-of select="$entity-class" /> e) {
		return getDao().create(e);
	}

	public <value-of select="$entity-class" /> retrieve(<text />
		<value-of select="$pk-type" /> id) {
		return getDao().retrieve(id);
	}

	public <value-of select="$entity-class" /> refresh(<text />
		<value-of select="$entity-class" /> e) {
		return getDao().retrieve(e.getId());
	}<text />

<if test="@code-table">

	public <value-of select="$entity-class" /> refreshByCode(final <text />
		<value-of select="$entity-class" /> e) {
		<value-of select="$criteria-class" /> c = new <text />
			<value-of select="$criteria-class" />();
		c.<value-of select="seaf:setter-name(per:code-table-field-name(.,'code','code'))" />
			<text />(e.getCode());<text />
		<if test="@code-table='time-bound'">
		applyTimeBoundCriteria(c);<text />
		</if>
		List&lt;<value-of select="$entity-class" />> found = getDao().find(c);
		if (0 == found.size()) {<text />
		<choose>
		<when test="@code-table='time-bound'">
			c = new <value-of select="$criteria-class" />();
			c.<value-of select="seaf:setter-name(per:code-table-field-name(.,'code','code'))" />
				<text />(e.getCode());
			List&lt;<value-of select="$entity-class" />> foundAll = getDao().find(c);
			if (0 == foundAll.size()) {
				throw new CodeNotFoundException(e);
			}
			throw new CodeNotValidException(e);
		}
		if (found.size() >= 2) {
			throw new MultipleValidCodesException(e);
		}<text />
		</when>
		<otherwise>
			throw new CodeNotFoundException(e);
		}
		if (!Boolean.TRUE.equals(found.get(0).getValid())) {
			throw new CodeNotValidException(e);
		}<text />
		</otherwise>
		</choose>
		return found.get(0);
	}<text />
</if>

<if test="@code-table='time-bound'">

	public void applyTimeBoundCriteria(<value-of select="$criteria-class" /> criteria) {
		Calendar now = Calendar.getInstance();
		criteria.<value-of select="seaf:setter-name(
			per:code-table-field-name(.,'valid-from','validFrom'))" />
			<text />(now);
		criteria.<value-of select="seaf:operator-field-name(seaf:setter-name(
			per:code-table-field-name(.,'valid-from','validFrom')))" />
			<text />(Operator.le);
		criteria.<value-of select="seaf:setter-name(
			per:code-table-field-name(.,'valid-until','validUntil'))" />
			<text />(now);
		criteria.<value-of select="seaf:operator-field-name(seaf:setter-name(
			per:code-table-field-name(.,'valid-until','validUntil')))" />
			<text />(Operator.geex);
	}<text />
</if>

	public void update(<value-of select="$entity-class" /> e) {
		getDao().update(e);
	}

	public void delete(<value-of select="$entity-class" /> e) {
		getDao().delete(e);
	}

	public List&lt;<value-of select="$entity-class" />> find(<text />
		<value-of select="$criteria-class" /> criteria) {
		return getDao().find(criteria);
	}

	public List&lt;<value-of select="$entity-class" />> findPage(<text />
		<value-of select="$criteria-class" /> criteria, Page page) {
		return getDao().find(criteria, page.getFromRecNo(), page.getCount());
	}

	public int size(<value-of select="$criteria-class" /> criteria) {
		return getDao().size(criteria);
	}<text />

<if test="@code-table">

	public List&lt;<value-of select="$entity-class" />> findAllValid() {
		<value-of select="$criteria-class" /> c = new <text />
			<value-of select="$criteria-class" />();<text />
		<if test="@code-table='time-bound'">
		applyTimeBoundCriteria(c);<text />
		</if>
		<if test="@code-table='code-based'">
		c.<value-of select="seaf:setter-name(per:code-table-field-name(.,'valid','valid'))" />
			<text />(true);<text />
		</if>
		return getDao().find(c);
	}<text />
</if>

	// Standard getters and setters

	/**
	 * Standard getter for the <value-of select="$dao-class" />.
	 * 
	 * @return <value-of select="$dao-class" />
	 */
	public <value-of select="$dao-class" /> getDao() {
		return dao;
	}

	/**
	 * Standard setter for the <value-of select="$dao-class" />.
	 * 
	 * @param dao
	 *            The <value-of select="$dao-class" /> instance
	 */
	public void setDao(<value-of select="$dao-class" /> dao) {
		this.dao = dao;
	}

}
<text />

</result-document>
</template>

<function name="per:code-table-field-name" as="xs:string">
<param name="entity" as="node()" />
<param name="type" as="xs:string" />
<param name="default" as="xs:string" />
	<variable name="field" select="$entity/per:field[@status=concat('code-table-',$type)]" />
	<choose>
	<when test="$field">
		<value-of select="$field/@name" />
	</when>
	<otherwise>
		<value-of select="$default" />
	</otherwise>
	</choose>
</function>

</stylesheet>
