package net.sf.seaf.persistence;

/**
 * Processes exceptions arising during refreshing code table property on entity.
 */
public interface CodeTablePropertyRefreshingExceptionProcessor {

	/**
	 * Process exception encountered when refreshing code table property on
	 * entity.
	 * 
	 * @param entity
	 *            Entity instance
	 * @param propertyType
	 *            Type of property being refreshed
	 * @param propertyName
	 *            Name of property being refreshed
	 * @param code
	 *            Code by which the property value is being refreshed
	 * @param cause
	 *            Exception encountered
	 */
	void process(Object entity, Class<?> propertyType, String propertyName,
			String code, Exception cause);

}
