package net.sf.seaf.persistence.exception;

import net.sf.seaf.persistence.CodeTable;

/**
 * Thrown from a code table server controller when a code does not exist in a
 * code table.
 */
public class CodeNotFoundException extends CodeTableException {

	private static final long serialVersionUID = -6199945023576454738L;

	/**
	 * Standard constructor.
	 * 
	 * @param instance
	 *            Instance of the code table containing the code
	 */
	public CodeNotFoundException(CodeTable instance) {
		super("Could not refresh " + instance.getClass().getSimpleName()
				+ " by code [" + instance.getCode()
				+ "]. No such code found in the code table.");
	}

}
