package net.sf.seaf.persistence.exception;

import net.sf.seaf.persistence.CodeTable;

/**
 * Thrown from a code table server controller when there are multiple valid
 * records with the given code in the code table.
 */
public class MultipleValidCodesException extends CodeTableException {

	private static final long serialVersionUID = -7771453727538471942L;

	/**
	 * Standard constructor.
	 * 
	 * @param instance
	 *            Instance of the code table containing the code
	 */
	public MultipleValidCodesException(CodeTable instance) {
		super("Could not refresh " + instance.getClass().getSimpleName()
				+ " by code [" + instance.getCode()
				+ "]. Multiple valid records with such code exist.");
	}

}
