package net.sf.seaf.persistence.util;

import net.sf.seaf.persistence.CodeTablePropertyRefreshingExceptionProcessor;
import net.sf.seaf.persistence.exception.CodeTablePropertyRefreshingException;

/**
 * Processes exceptions arising during refreshing code table property on entity
 * by throwing a corresponding {@link CodeTablePropertyRefreshingException}.
 */
public class ThrowingCodeTablePropertyRefreshingExceptionProcessor implements
		CodeTablePropertyRefreshingExceptionProcessor {

	private static final ThrowingCodeTablePropertyRefreshingExceptionProcessor instance = new ThrowingCodeTablePropertyRefreshingExceptionProcessor();

	/**
	 * Returns a default instance of
	 * ThrowingCodeTablePropertyRefreshingExceptionProcessor.
	 * 
	 * @return A default instance of
	 *         ThrowingCodeTablePropertyRefreshingExceptionProcessor
	 */
	public static ThrowingCodeTablePropertyRefreshingExceptionProcessor getInstance() {
		return instance;
	}

	public void process(Object entity, Class<?> propertyType,
			String propertyName, String code, Exception cause) {
		throw new CodeTablePropertyRefreshingException(entity.getClass(),
				propertyType, propertyName, code, cause);
	}

}
